;; isearch.sl
;; Routines here perform incremental forward/backward searches
;; 
;; ESCAPE key aborts the search
;; ENTER key finds next match
;; DELETE key deletes last character entered and returns to previous point
;;
;;  "isearch_forward"	"^FIf"   setkey  ;(sample bindings)
;;  "isearch_backward"	"^FIb"   setkey

(
   [str] =str
   [n] str strlen =n
   n {
       str 1 n 1 - substr =str
     } if
   str
) isearch_del

(
  [dir] =dir
  [prompt] "Isearch " dir 1 == {"forward: "}{"Backward: "} else strcat =prompt 
  [str] "" =str
  [c m] push_mark 1 =m
  
  {
     prompt str strcat message
     update
     getkey =c
     c { 27 == : break }
       { 13 == : dir 1 == { 1 right pop } if }
       { 127 == : str isearch_del =str 
                  m {m 1 - =m 1 pop_mark pop } if
		  m {1 =m push_mark} !if
		  continue
       }
       { char str exch strcat =str
         m 1 + =m push_mark
	 str looking_at 1 dir == and {1 right pop} if
       }
     switch
     
     
     str dir 1 == {fsearch}{bsearch} else
     {
       str " not found." strcat message flush beep
       1 input_pending pop
       c 13 == {1 left pop} 
               {str isearch_del =str 0 pop_mark pop m 1 - =m}
	     else
     } !if
     
  } forever
  m { 0 pop_mark pop } loop
  "Done." message
) isearch_dir

( 1 isearch_dir )  isearch_forward 
( -1 isearch_dir ) isearch_backward

  
