#REM            Site specific initialiation file.

This file must be present in the JED_LIBRARY.  JED loads it first--- even
before reading command line arguments.  The command line arguments are then 
passed to a hook declared in this file for further processing.

In addition to some hooks, this file declares some autoloads for various 
functions and defines utility functions.  Any user specific stuff should be 
placed in the jed.rc (.jedrc) user startup file.  Only put here what you 
believe EVERY user on your system should get!

#end rem

;; default character set.  European systems might want to comment out
;; one of these lines.  It is only really necessary if the associated slang
;; files are modified since the editors uses the definitions in these files 
;; by default.
; "iso-latin.sl" evalfile pop  ;; NOT MSDOS! (default set -- not needed)
; "dos850.sl" evalfile pop   ;; MSDOS ONLY!!
; "dos437.sl" evalfile pop   ;; MSDOS ONLY!! (default set -- not needed)

;;
;; key definitions
;;
"help"		"^H^H"  setkey
"apropos"	"^HA"	setkey      
"help_fun"	"^HF"	setkey     
"where_is"	"^HW"	setkey     
"showkey"	"^HC"	setkey
"do_shell_cmd"	"^[!"	setkey
"find_tag"	 "^[."	setkey
"save_buffers"	"^Xs"	setkey
"list_buffers"	"^X^B"	setkey
#UNIX
  "unix_man" 	"^Hm"	setkey
  "ispell"	"^[$"	setkey
#end

;;
;;  Autoloads
;;

#MSDOS
"lpr"			"lpr.sl"	autoload
#end
#VMS
"dcl"			"dcl.sl"	autoload
#end
"trim_buffer"		"util.sl"	autoload  ;; trims excess lines and space
"bol_fsearch"		"util.sl"	autoload
"bol_bsearch"		"util.sl"	autoload
"occur"			"util.sl"	autoload  ;; find all command
"list_buffers"		"buf.sl"	autoload
"sort"			"sort.sl"	autoload
"untab"			"untab.sl"	autoload
"fortran"		"fortran.sl"	autoload
"save_buffers"		"buf.sl"	autoload
"rot13"			"rot13.sl"	autoload
"isearch_forward"	"isearch.sl"	autoload
"isearch_backward"	"isearch.sl"	autoload
"shell"			"shell.sl"	autoload
"do_shell_cmd"		"shell.sl"	autoload
"find_tag"		"ctags.sl"	autoload
"apropos"		"help.sl"	autoload
"help_fun"		"help.sl"	autoload
"where_is"		"help.sl"	autoload
;;
;; By default, tabs are every TAB columns (default 8).  Calling this function
;; will allow the user to set the tabs arbitrarily and bind the TAB key
;; appropriately.
"edit_tab_stops"	"tabs.sl"	autoload


#UNIX
  "unix_man"	"man.sl"	autoload
  "mail"	"mail.sl"	autoload
  "rmail"	"rmail.sl"	autoload
  "ispell"	"ispell.sl"	autoload
#end UNIX


;; A useful hooks function---
;; There is a builtin one in slang as well that is called from C code
( [hook_fun] =hook_fun
  hook_fun defined? { hook_fun eval } if
) runhooks

;;
;; A function to contat a directory with a filename.  Basically checks
;;  for the final slash on the dir and adds on if necessary
;;   

(
   [dir file] =file =dir
   [n] dir strlen =n
#IBMPC
   [slash] "\\" =slash

   n {
       dir n 1 substr slash strcmp {dir slash strcat =dir} if
     } if
   dir file strcat
#end
#UNIX
   [slash] "/" =slash

   n {
       dir n 1 substr slash strcmp {dir slash strcat =dir} if
     } if
   dir file strcat
#end
#VMS
   dir file strcat return
#end
) dircat


;;; scroll other window macros-- bind them yourself
( nwindows 1 -
  otherwindow
  "page_up" call
  { otherwindow } loop
) next_wind_up  
;; "next_wind_up"  "^W^[[A"  setkey
  
( nwindows 1 -
  otherwindow
  "page_down" call
  { otherwindow } loop
) next_wind_dn 
;; "next_wind_dn" "^W^[[B"  setkey

;; some file hooks
;; called everytime a file is read into buffer to set the mode.
(
  {"c"   strcmp not : "cmode" setmode }
  {"h"   strcmp not : "cmode" setmode }
  {"tex" strcmp not : "wrap" setmode }
  {"txt" strcmp not : "wrap" setmode }
  {"doc" strcmp not : "wrap" setmode }
  {"f"   strcmp not : fortran }
  {"for" strcmp not : fortran }
#VMS
  {"com" strcmp not : dcl }
#end
  {"sl"  strcmp not : "nomode" setmode }
  {"rc"  strcmp not : "nomode" setmode }
#UNIX
  {"jedrc"  strcmp not : "nomode" setmode }
  {"cshrc"  strcmp not : "nomode" setmode }
  {"tcshrc"  strcmp not : "nomode" setmode }
  {"login"  strcmp not : "nomode" setmode }
  {"profile"  strcmp not : "nomode" setmode }
#end
  {pop "wrap" setmode} ;;  default
  switch
) mode_hook

;; sets buf modified flag
(
   [mod] =mod
   getbuf_info
   mod { 1 | }{1 ~ &} else
   setbuf_info
) set_buffer_modified_flag

;; exch was removed for some reason
(
   [x y] =x  =y x y 
) exch

;; Toggle buffer read only
(
   getbuf_info
   8 xor setbuf_info
) toggle_readonly

;; toggle overwrite mode
(
   getbuf_info
   32 xor setbuf_info
) toggle_overwrite

(
   [n] =n
   getbuf_info
   n { 8 |}{8 ~ &} else setbuf_info
) set_readonly

(
   [n] =n
   getbuf_info
   n { 32 |}{32 ~ &} else setbuf_info
) set_overwrite


;; command line hook
;; called from main in executable.  Top element of stack is number of 
;; command line parameters--- n.  The next n elements are the command
;; line parameters.  argv[0] is NOT passed.
( [n i file] =n
  [mark] "@#$thisisamark@#$" =mark
  [jedrc home] "jed.rc" =jedrc
#UNIX 
  ".jedrc" =jedrc
#end

  "JED_HOME" getenv =home
  home strlen 
   {
     "HOME" getenv =home
#VMS 
     "SYS$LOGIN:" =home
#end
   } !if
   
   home jedrc dircat =jedrc
;; if first argument is -n then do NOT load init file
   
   {n not}{dup "-n" strcmp} orelse 
   {
     mark
     jedrc file_status 1 == {jedrc evalfile} if
     {string mark strcmp}{} while  ;; user may have left stuff on stack
   }{ n { pop n 1 - =n} if }
   else
   
  {n} { =file
         n 1 - =n
         file {"-f" strcmp not n and : eval }
	      {"-g" strcmp not n and : integer goto_line }
	      {"-s" strcmp not n and : fsearch pop }
	      {"-l" strcmp not n and : evalfile pop }
	      {find_file pop n 1 + =n}
	     switch
	 n 1 - =n
      } while
) command_line_hook


;; startup hook
(
   [n hlp ok] 0 =ok
   "mini.sl" evalfile pop  
   "help" which_key =n 
   n {return} !if
   =hlp hlp
   n { 
      "^H^H" strcmp {
      "help: ^H^H  ShowKey: ^HC  ManPage: ^HM  Describe Function: ^HF Apropos: ^HA"
       message
       1 =ok
       } !if
     } loop
   ok {"For help, enter " hlp strcat message} !if
) jed_startup_hook


( "Line:" whatline string strcat
  " Column:" what_column string strcat strcat message ) whatpos
  
  "whatpos" "^X?" setkey
;;
;; help function for JED
;;
(
   [hlp] "*help*"  =hlp
   [lib] "JED_LIBRARY" getenv =lib
   [file buf]
   [rows]
   
   whatbuf =buf
   onewindow
   window_size pop =rows
   "Emacs_Loaded" defined? {"emacs.hlp"}{"jed.hlp"} else =file
   hlp setbuf 
   0 set_readonly
   erase_buffer
   lib file dircat insert_file 0 < {"Help file not found!" error} if
   hlp pop2buf bob
   0 set_buffer_modified_flag
   1 set_readonly
   buf pop2buf
   rows 2 / 7 - {enlargewin} loop
) help

#VMS
;; This resume hook is need for VMS when returning from spawn.
;; In fact, it is NEEDED for certain JED functions on VMS so declare it.
( [file]
  "JED_FILE_NAME" getenv =file
  file strlen {return} !if
  file find_file {"File not found!" error} !if
) resume_hook
#end VMS
