;;
;;  utility functions which Must be available (e.g., autoload)
;;

;; Since this version of JED uses Linked-List approach and does not
;; support regular expressions, it is hard to search for strings at the 
;; beginning or end of a line.  Here are some functions which do this:

(           ;; bol_fsearch  returns 0 if not found
  [s] =s    ;; sample usage:  push_spot "string" bol_fsearch
            ;;                {pop_spot} !if
  {1 down}
  { bol s looking_at {1 return} if }
  while
  0
) bol_fsearch


(  [str] =str
   
   {str bsearch}{bolp { 1 return } if } while
   0
) bol_bsearch


;;
;;  A routine that trims the buffer by:  removing excess whitespace at the
;;  end of lines and removing excess newlines
;;

(
  push_spot
  bob
  {1} {
	eol trim bol 
	eolp {
	  1 down pop
	  { {eol trim bol eolp } {eobp 0 ==} andelse } { del } while
	} if
	1 down {break} !if
      } while
  bob eol trim bol eolp {del} if
  pop_spot
) trim_buffer
      
(
   getbuf_info
   1 xor setbuf_info
) tog_bufmod


;; occur function
;;
(
  [str cbuf tmp]  ;; local variables
  "Find All:" "" read_mini =str
  "*occur*" =tmp whatbuf =cbuf
  tmp bufferp { tmp delbuf } if
  push_spot
  {str fsearch}
    {
       whatline string 
       push_mark
       narrow
       tmp setbuf
       insert 5 goto_column ":"  insert
       cbuf insbuf "\n" insert
       cbuf setbuf
       widen
       eol             ;; so we do not find another occurance on same line
    } while
    pop_spot
    ;; did we make it
    tmp bufferp { tmp pop2buf bob } if
) occur 




# 082
;;
;;  Extract Directory Name from a File  (includes device)
;;
( [dir_file] =dir_file
  [nul] "" =nul
  [pos len] 
  dir_file strlen =len
;; VMS
   "]" dir_file is_substr =pos
   pos {nul return} !if
   dir_file pos len substr
#end
